#!/usr/bin/env python3

#This python code is from: http://numbergazing.org/
#by Gregory Bryant

from copy import copy as cpy

class nlist:
    
    #def plusplus(self,n):
    #    return n+1

    #def __init__(self,func, start, end,data=0,incFunc=plusplus):
    def __init__(self,func, start, end,data=0):
        if data is 0:
            self.data=[]
            if end >= start:
                for i in range(start,end+1):
                    self.data.append((i,func(i)))
            else:
                for i in range(start,end-1,-1):
                    self.data.append((i,func(i)))
        else:
            self.data=data

    def copy(self):
        return cpy(self)
    
    def to_file(self,fileName):
        outFile = open(fileName, 'w')
        outFile.write("#"+fileName+",\n");
        for i in self.data:
            outFile.write(str(i[0])+","+str(i[1])+"\n")
        outFile.close()

    def to_file_x(self,fileName):
        outFile = open(fileName, 'w')
        for i in self.data:
            outFile.write(str(i[0])+",")
        outFile.write("\n")
        outFile.close()

    def to_file_y(self,fileName):
        outFile = open(fileName, 'w')
        for i in self.data:
            outFile.write(str(i[1])+",")
        outFile.write("\n")
        outFile.close()

    def print(self):
        print(self.data)

    def print_y(self):
        for i in self.data:
            print(i[1],end=",")
        print

    def swap_x_y(self):
        for i in range(0,len(self.data)):
            self.data[i] = (self.data[i][1],self.data[i][0])
        return self

    def x_differences(self):
        alist=[]
        for i in range(0,int(len(self.data)-2)+1):
            alist.append((i+1,self.data[i+1][0]-self.data[i][0]))
        return nlist(0,0,0,alist)

    def y_differences(self):
        alist=[]
        for i in range(0,int(len(self.data)-2)+1):
            alist.append((i+1,self.data[i+1][1]-self.data[i][1]))
        return nlist(0,0,0,alist)

    def delete_matches(self,matches):
        return nlist(0,0,0,data=[x for x in self.data if x not in matches.data])

    def pop_max_y(self):
        maxy = self.max_y()
        newlist = self.delete_matches(maxy)
        self.data = newlist.data
        return maxy

    def max_y(self):
        """returns an nlist of the maximal y values from the given nlist"""
        maxData = []
        maxY=0
        for i in self.data:
            if i[1]>maxY:
                maxY=i[1]
                maxData.append(i)
        return nlist(0,0,0,maxData)

    def difference(self,nlist2):
        data3=[]
        for i in range(0,len(self.data)):
            data3.append((self.data[i][0],self.data[i][1]-nlist2.data[i][1]))
        return nlist(0,0,0,data3)
   
    @classmethod
    def make_difference(self,func1,func2,start,end):
        n1 = nlist(func1,start,end)
        n2 = nlist(func2,start,end)
        return n1.difference(n2)

    def ratio(self,nlist2):
        data3=[]
        for i in range(0,len(self.data)):
            data3.append((self.data[i][0],self.data[i][1]/nlist2.data[i][1]))
        return nlist(0,0,0,data3)

    @classmethod
    def make_ratio(self,func1,func2,start,end):
        n1 = nlist(func1,start,end)
        n2 = nlist(func2,start,end)
        return n1.ratio(n2)


if __name__ == "__main__":
    print("This is the nlist class module")